
Trait named: #STAccessor
	uses: {}
	category: 'SqueakTesting-Assertion'!

!STAccessor methodsFor: 'accessing' stamp: 'lr 4/3/2006 08:38'!
assertion
	^ STAssertion new! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/29/2006 21:44'!
assert: aBoolean
	self assertion 
		assert: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:42'!
assert: aBoolean description: aString
	self assertion
		description: aString;
		assert: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:42'!
assert: aBoolean description: aString resumable: resumableBoolean 
	self assertion
		description: aString;
		resumable: resumableBoolean;
		assert: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/29/2006 21:44'!
deny: aBoolean
	self assertion
		deny: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:43'!
deny: aBoolean description: aString
	self assertion
		description: aString;
		deny: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:43'!
deny: aBoolean description: aString resumable: resumableBoolean 
	self assertion
		description: aString;
		resumable: resumableBoolean;
		deny: aBoolean! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/29/2006 21:44'!
shouldnt: aBlock
	self assertion
		shouldnt: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:47'!
shouldnt: aBlock description: aString
	self assertion
		description: aString;
		shouldnt: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:47'!
shouldnt: aBlock raise: anException
	self assertion
		exception: anException;
		shouldnt: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:48'!
shouldnt: aBlock raise: anException description: aString
	self assertion
		exception: anException;
		description: aString;
		shouldnt: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/29/2006 21:44'!
should: aBlock
	self assertion
		should: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:47'!
should: aBlock description: aString
	self assertion
		description: aString;
		should: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:48'!
should: aBlock raise: anException
	self assertion
		exception: anException;
		should: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 20:48'!
should: aBlock raise: anException description: aString
	self assertion
		exception: anException;
		description: aString;
		should: aBlock! !

!STAccessor methodsFor: 'convenience' stamp: 'lr 3/27/2006 21:03'!
signalFailure: aString
	self assertion description: aString; fail! !

Trait named: #STListener
	uses: {}
	category: 'SqueakTesting-Listener'!

!STListener methodsFor: 'events' stamp: 'lr 3/31/2006 08:03'!
on: aRunner after: aTest! !

!STListener methodsFor: 'events' stamp: 'lr 3/31/2006 08:04'!
on: aRunner before: aTest! !

!STListener methodsFor: 'events' stamp: 'lr 4/3/2006 09:24'!
on: aRunner begin: aTest! !

!STListener methodsFor: 'events' stamp: 'lr 4/3/2006 09:24'!
on: aRunner end: aTest! !

!STListener methodsFor: 'events' stamp: 'lr 3/30/2006 08:02'!
on: aRunner error: aTest with: anError! !

!STListener methodsFor: 'events' stamp: 'lr 3/30/2006 08:02'!
on: aRunner failure: aTest with: aFailure! !

!STListener methodsFor: 'events' stamp: 'lr 3/30/2006 08:00'!
on: aRunner ignored: aTest! !

!STListener methodsFor: 'events' stamp: 'lr 3/31/2006 01:04'!
on: aRunner passed: aTest! !

Trait named: #STTestTrait
	uses: STAccessor
	category: 'SqueakTesting-Core'!

!STTestTrait classSide methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:29'!
suite
	^ (Pragma allNamed: #test in: self)
		inject: STTestSuite new
		into: [ :suite :pragma | 
			suite add: (STTestMethod class: self selector: pragma selector)
				wrapped ]! !

Trait named: #STVisitable
	uses: {}
	category: 'SqueakTesting-Visitor'!

!STVisitable methodsFor: 'visiting' stamp: 'lr 3/31/2006 13:34'!
accept: aVisitor! !

Trait named: #STVisitor
	uses: {}
	category: 'SqueakTesting-Visitor'!

!STVisitor methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:55'!
visitAll: aCollection
	aCollection do: [ :each | each accept: self ]! !

!STVisitor methodsFor: 'visiting-decoration' stamp: 'lr 4/18/2006 07:26'!
visitDecoration: aTest
	self visit: aTest next! !

!STVisitor methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 09:37'!
visitGroupedTest: aTest
	self visitDecoration: aTest! !

!STVisitor methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 09:37'!
visitIgnoredTest: aTest
	self visitDecoration: aTest! !

!STVisitor methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 09:37'!
visitRepeatedTest: aTest
	self visitDecoration: aTest! !

!STVisitor methodsFor: 'visiting-core' stamp: 'lr 4/3/2006 09:36'!
visitTestCase: aTest! !

!STVisitor methodsFor: 'visiting-core' stamp: 'lr 4/3/2006 09:37'!
visitTestMethod: aTest
	self visitTestCase: aTest! !

!STVisitor methodsFor: 'visiting-core' stamp: 'lr 4/18/2006 07:29'!
visitTestSuite: aTest
	self visitAll: aTest tests! !

!STVisitor methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 09:37'!
visitTimeoutTest: aTest
	self visitDecoration: aTest! !

!STVisitor methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:55'!
visit: anObject
	anObject accept: self! !

STTestTrait classTrait
	uses: STAccessor classTrait!
SystemOrganization addCategory: #'SqueakTesting-Core'!
SystemOrganization addCategory: #'SqueakTesting-Decoration'!
SystemOrganization addCategory: #'SqueakTesting-Assertion'!
SystemOrganization addCategory: #'SqueakTesting-Listener'!
SystemOrganization addCategory: #'SqueakTesting-Tests'!
SystemOrganization addCategory: #'SqueakTesting-Visitor'!

Exception subclass: #STFailure
	instanceVariableNames: 'assertion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Assertion'!

!STFailure class methodsFor: 'instance-creation' stamp: 'lr 5/18/2006 07:31'!
on: anAssertion
	^ self new initializeWith: anAssertion! !

!STFailure methodsFor: 'accessing' stamp: 'lr 3/27/2006 20:30'!
assertion
	^ assertion! !

!STFailure methodsFor: 'defaults' stamp: 'lr 3/27/2006 20:39'!
defaultAction
	Processor activeProcess
		debug: self signalerContext
		title: self description! !

!STFailure methodsFor: 'initialization' stamp: 'lr 4/3/2006 10:41'!
initializeWith: anAssertion
	assertion := anAssertion! !

!STFailure methodsFor: 'testing' stamp: 'lr 3/27/2006 20:30'!
isResumable
	^ self assertion resumable! !

!STFailure methodsFor: 'accessing' stamp: 'lr 3/29/2006 21:49'!
messageText
	^ self assertion description ifNil: [ super messageText ]! !

Object subclass: #STAssertion
	instanceVariableNames: 'description resumable exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Assertion'!

!STAssertion methodsFor: 'public' stamp: 'lr 4/3/2006 10:37'!
assert: aBoolean
	aBoolean ifTrue: [ ^ self ].
	self failure signal: self! !

!STAssertion methodsFor: 'public' stamp: 'lr 3/29/2006 21:50'!
deny: aBoolean
	self assert: aBoolean not! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 20:21'!
description
	^ description! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 21:10'!
description: aString
	description := aString! !

!STAssertion methodsFor: 'private' stamp: 'lr 3/29/2006 21:46'!
evaluate: aBlock
	self exception
		ifNil: [ ^ aBlock value ].
	^ [ aBlock value. false ]
		on: self exception
		do: [ :err | true ]! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 20:21'!
exception
	^ exception! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 21:10'!
exception: anException
	exception := anException! !

!STAssertion methodsFor: 'public' stamp: 'lr 3/29/2006 21:50'!
fail
	self assert: false! !

!STAssertion methodsFor: 'private' stamp: 'lr 4/3/2006 10:42'!
failure
	^ self failureClass on: self! !

!STAssertion methodsFor: 'private' stamp: 'lr 4/3/2006 08:39'!
failureClass
	^ STFailure! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 20:22'!
resumable
	^ resumable ifNil: [ false ]! !

!STAssertion methodsFor: 'accessing' stamp: 'lr 3/27/2006 21:10'!
resumable: aBoolean
	resumable := aBoolean! !

!STAssertion methodsFor: 'public' stamp: 'lr 3/29/2006 21:50'!
shouldnt: aBlock
	self deny: (self evaluate: aBlock)! !

!STAssertion methodsFor: 'public' stamp: 'lr 3/29/2006 21:50'!
should: aBlock
	self assert: (self evaluate: aBlock)! !

Object subclass: #STDispatcher
	uses: STListener
	instanceVariableNames: 'listeners'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Listener'!

STDispatcher class
	uses: STListener classTrait
	instanceVariableNames: ''!

!STDispatcher methodsFor: 'registration' stamp: 'lr 4/3/2006 20:05'!
add: aListener
	self listeners add: aListener! !

!STDispatcher methodsFor: 'initialization' stamp: 'lr 4/3/2006 20:05'!
initialize
	super initialize.
	listeners := Set new! !

!STDispatcher methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:46'!
listeners
	^ listeners! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:07'!
on: aRunner after: aTest
	self listeners do: [ :each | each on: aRunner after: aTest ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner before: aTest
	self listeners do: [ :each | each on: aRunner before: aTest ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner begin: aTest
	self listeners do: [ :each | each on: aRunner begin: aTest ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner end: aTest
	self listeners do: [ :each | each on: aRunner end: aTest ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner error: aTest with: anError
	self listeners do: [ :each | each on: aRunner error: aTest with: anError ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner failure: aTest with: aFailure
	self listeners do: [ :each | each on: aRunner failure: aTest with: aFailure ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner ignored: aTest
	self listeners do: [ :each | each on: aRunner ignored: aTest ]! !

!STDispatcher methodsFor: 'events' stamp: 'lr 4/3/2006 20:08'!
on: aRunner passed: aTest
	self listeners do: [ :each | each on: aRunner passed: aTest ]! !

!STDispatcher methodsFor: 'registration' stamp: 'lr 4/3/2006 20:07'!
remove: aListener
	self listeners remove: aListener! !

Object subclass: #STLogger
	uses: STListener
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Listener'!

STLogger class
	uses: STListener classTrait
	instanceVariableNames: ''!

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 08:05'!
on: aRunner after: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' after: '; print: aTest;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 08:06'!
on: aRunner before: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' before: '; print: aTest;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 08:06'!
on: aRunner begin: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' begin: '; print: aTest;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 08:06'!
on: aRunner end: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' end: '; print: aTest;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 01:07'!
on: aRunner error: aTest with: anError
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' error: '; print: aTest;
		nextPutAll: ' with: '; print: anError;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 01:07'!
on: aRunner failure: aTest with: aFailure
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' failure: '; print: aTest;
		nextPutAll: ' with: '; print: aFailure;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 01:07'!
on: aRunner ignored: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' ignored: '; print: aTest;
		cr! !

!STLogger methodsFor: 'events' stamp: 'lr 3/31/2006 01:07'!
on: aRunner passed: aTest
	self stream
		nextPutAll: 'on: '; print: aRunner;
		nextPutAll: ' passed: '; print: aTest;
		cr! !

!STLogger methodsFor: 'accessing' stamp: 'lr 3/30/2006 00:18'!
stream
	^ Transcript! !

Object subclass: #STObjectTest
	uses: STTestTrait
	instanceVariableNames: 'foo bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Tests'!

STObjectTest class
	uses: STTestTrait classTrait
	instanceVariableNames: ''!

!STObjectTest methodsFor: 'running' stamp: 'lr 4/3/2006 20:22'!
setUpBar
	<setUp>
	
	bar := #bar! !

!STObjectTest methodsFor: 'running' stamp: 'lr 4/3/2006 20:22'!
setUpFoo
	<setUp>
	
	foo := #foo! !

!STObjectTest methodsFor: 'testing' stamp: 'lr 4/3/2006 20:22'!
testZork
	<test>
	
	self assert: foo = #foo.
	self assert: bar = #bar! !

Object subclass: #STResult
	uses: STListener
	instanceVariableNames: 'passed ignored failures errors started duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Listener'!

STResult class
	uses: STListener classTrait
	instanceVariableNames: ''!

!STResult methodsFor: 'accessing-dynamic' stamp: 'lr 3/29/2006 15:57'!
color
	^ self hasPassed
		ifTrue: [ Color green ]
		ifFalse: [
			self hasErrors
				ifFalse: [ Color yellow ]
				ifTrue: [ Color red ] ]! !

!STResult methodsFor: 'accessing-timeing' stamp: 'lr 3/29/2006 15:32'!
duration
	^ duration ifNil: [ TimeStamp now - self started ]! !

!STResult methodsFor: 'accessing' stamp: 'lr 3/29/2006 15:23'!
errors
	^ errors! !

!STResult methodsFor: 'accessing' stamp: 'lr 3/29/2006 15:22'!
failures
	^ failures! !

!STResult methodsFor: 'testing' stamp: 'lr 3/29/2006 15:15'!
hasErrors
	^ self errors notEmpty! !

!STResult methodsFor: 'testing' stamp: 'lr 3/29/2006 15:15'!
hasFailures
	^ self failures notEmpty! !

!STResult methodsFor: 'testing' stamp: 'lr 3/29/2006 15:34'!
hasIgnored
	^ self ignored notEmpty! !

!STResult methodsFor: 'testing' stamp: 'lr 3/29/2006 15:20'!
hasPassed
	^ self errors isEmpty and: [ self failures isEmpty ]! !

!STResult methodsFor: 'accessing' stamp: 'lr 3/29/2006 15:22'!
ignored
	^ ignored! !

!STResult methodsFor: 'initialization' stamp: 'lr 3/31/2006 00:56'!
initialize
	super initialize.
	passed := Set new.
	ignored := Set new.
	failures := Dictionary new. 
	errors := Dictionary new! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 08:05'!
on: aRunner begin: aSuite
	started := TimeStamp now.
	duration := nil! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 08:05'!
on: aRunner end: aSuite
	duration := self duration! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 00:48'!
on: aRunner error: aTest with: anError
	self errors at: aTest put: anError! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 00:48'!
on: aRunner failure: aTest with: aFailure
	(self failures at: aTest ifAbsentPut: [ Set new ])
		add: aFailure! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 00:48'!
on: aRunner ignored: aTest
	self ignored add: aTest! !

!STResult methodsFor: 'events' stamp: 'lr 3/31/2006 01:08'!
on: aRunner passed: aTest
	self passed add: aTest! !

!STResult methodsFor: 'accessing' stamp: 'lr 3/31/2006 00:46'!
passed
	^ passed! !

!STResult methodsFor: 'printing' stamp: 'lr 3/31/2006 00:56'!
printOn: aStream
	aStream print: self passed size; nextPutAll: ' run'.
	self hasFailures
		ifTrue: [ aStream nextPutAll: ', '; print: self failures size; nextPutAll: ' failures' ].
	self hasErrors
		ifTrue: [ aStream nextPutAll: ', '; print: self errors size; nextPutAll: ' errors' ].
	self hasIgnored
		ifTrue: [ aStream nextPutAll: ', '; print: self ignored size; nextPutAll: ' ignored' ]! !

!STResult methodsFor: 'accessing-timeing' stamp: 'lr 3/29/2006 15:32'!
started
	^ started! !

Object subclass: #STRunner
	uses: STVisitor
	instanceVariableNames: 'listener'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Core'!

STRunner class
	uses: STVisitor classTrait
	instanceVariableNames: ''!

!STRunner methodsFor: 'initialization' stamp: 'lr 4/3/2006 20:43'!
initialize
	super initialize.
	listener := STDispatcher new! !

!STRunner methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:40'!
listener
	^ listener! !

!STRunner methodsFor: 'private' stamp: 'lr 5/18/2006 07:35'!
perform: aTest
	| passed |
	passed := true.
	[ [ [ aTest setUp; run ] 
		ensure: [ aTest tearDown ] ]
			on: STFailure
			do: [ :failure | 
				self listener on: self failure: aTest with: failure. 
				passed := false ] ]
					on: Error
					do: [ :error | 
						self listener on: self error: aTest with: error.
						passed := false ].
	passed ifTrue: [ self listener on: self passed: aTest ]! !

!STRunner methodsFor: 'running' stamp: 'lr 4/3/2006 20:40'!
run: aTest
	self listener on: self begin: aTest owner.
	[ self visit: aTest ]
		ensure: [ self listener on: self end: aTest owner ]! !

!STRunner methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 20:42'!
visitIgnoredTest: aTest
	self listener on: self ignored: aTest owner! !

!STRunner methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 09:27'!
visitRepeatedTest: aTest
	aTest count timesRepeat: [ self visit: aTest next ]! !

!STRunner methodsFor: 'visiting-core' stamp: 'lr 4/3/2006 20:41'!
visitTestCase: aTest
	self listener on: self before: aTest.
	self perform: aTest.
	self listener on: self after: aTest! !

!STRunner methodsFor: 'visiting-core' stamp: 'lr 4/3/2006 20:41'!
visitTestSuite: aTest
	self listener on: self before: aTest.
	self visitAll: aTest tests.
	self listener on: self after: aTest! !

!STRunner methodsFor: 'visiting-decoration' stamp: 'lr 4/3/2006 10:38'!
visitTimeoutTest: aTest
	[ self visit: aTest next ]
		valueWithin: aTest timeout milliSeconds 
		onTimeout: [ 
			self 
				on: self error: aTest owner 
				with: (aTest owner assertion
					description: 'Timeout after ' , aTest timeout printString , ' ms';
					failure) ]! !

Object subclass: #STTest
	uses: STVisitable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Core'!

STTest class
	uses: STVisitable classTrait
	instanceVariableNames: ''!

STTest subclass: #STDecoration
	uses: STVisitable
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Decoration'!

STDecoration class
	uses: STVisitable classTrait
	instanceVariableNames: ''!

!STDecoration class methodsFor: 'instance-creation' stamp: 'lr 4/3/2006 08:44'!
on: aTest
	^ self new initializeWith: aTest! !

!STDecoration methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:11'!
accept: aVisitor
	aVisitor acceptDecoration: self! !

!STDecoration methodsFor: 'initialization' stamp: 'lr 4/3/2006 08:44'!
initializeWith: aTest
	next := aTest! !

!STDecoration methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:33'!
next
	^ next! !

!STDecoration methodsFor: 'accessing' stamp: 'lr 4/3/2006 08:43'!
owner
	^ self next owner! !

STDecoration subclass: #STGroupedTest
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Decoration'!

!STGroupedTest methodsFor: 'visiting' stamp: 'lr 4/3/2006 08:41'!
accept: aVisitor
	aVisitor visitGroupedTest: self ! !

!STGroupedTest methodsFor: 'accessing' stamp: 'lr 4/3/2006 08:41'!
name
	^ name! !

!STGroupedTest methodsFor: 'accessing' stamp: 'lr 4/3/2006 08:41'!
name: aString
	name := aString! !

STDecoration subclass: #STIgnoredTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Decoration'!

!STIgnoredTest methodsFor: 'visiting' stamp: 'lr 3/31/2006 13:35'!
accept: aVisitor
	aVisitor visitIgnoredTest: self ! !

STDecoration subclass: #STRepeatedTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Decoration'!

!STRepeatedTest commentStamp: 'lr 3/27/2006 21:26' prior: 0!
A decorator that runs a test repeatedly.!

!STRepeatedTest methodsFor: 'visiting' stamp: 'lr 3/31/2006 13:37'!
accept: aVisitor
	aVisitor visitRepeatedTest: self ! !

!STRepeatedTest methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:36'!
count
	^ count! !

!STRepeatedTest methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:35'!
count: anInteger
	count := anInteger! !

STDecoration subclass: #STTimeoutTest
	instanceVariableNames: 'timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Decoration'!

!STTimeoutTest methodsFor: 'visiting' stamp: 'lr 3/31/2006 13:37'!
accept: aVisitor
	aVisitor visitTimeoutTest: self! !

!STTimeoutTest methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:36'!
timeout
	^ timeout! !

!STTimeoutTest methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:36'!
timeout: anInteger
	timeout := anInteger! !

STTest subclass: #STTestCase
	uses: STAccessor
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Core'!

STTestCase class
	uses: STAccessor classTrait
	instanceVariableNames: ''!

STTestCase subclass: #STAssertionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Tests'!

!STAssertionTest methodsFor: 'testing' stamp: 'lr 4/18/2006 07:30'!
testAssert
	<group: #basic>
	
	self assert: true! !

!STAssertionTest methodsFor: 'testing' stamp: 'lr 4/18/2006 07:30'!
testDeny
	<group: #basic>
	<group: #foo>
	
	self deny: false! !

!STAssertionTest methodsFor: 'testing' stamp: 'lr 3/30/2006 00:22'!
testShould
	self should: [ true ]! !

!STAssertionTest methodsFor: 'testing' stamp: 'lr 3/30/2006 00:24'!
testShouldnt
	self shouldnt: [ false ]! !

!STAssertionTest methodsFor: 'testing' stamp: 'lr 3/30/2006 00:35'!
testShouldntRaise
	self should: [ 1 / 0 ] raise: ZeroDivide! !

!STAssertionTest methodsFor: 'testing' stamp: 'lr 3/30/2006 00:23'!
testShouldRaise
	self should: [ 1 / 0 ] raise: ZeroDivide! !

!STTestCase class methodsFor: 'instance-creation' stamp: 'lr 4/3/2006 20:28'!
selector: aSelector
	^ self new setSelector: aSelector! !

!STTestCase class methodsFor: 'accessing' stamp: 'lr 4/3/2006 09:48'!
suite
	^ self selectors
		inject: STTestSuite new
		into: [ :suite :each |
			suite add: (self selector: each)
				wrapped ]! !

!STTestCase methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:19'!
accept: aVisitor
	aVisitor visitTestCase: self! !

!STTestCase methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:15'!
instance
	^ self! !

!STTestCase methodsFor: 'accessing' stamp: 'lr 4/3/2006 09:50'!
pragmas
	^ (self species methodDict at: self selector) pragmas! !

!STTestCase methodsFor: 'printing' stamp: 'lr 4/3/2006 08:50'!
printOn: aStream
	aStream nextPutAll: self species name; nextPutAll: '>>'; nextPutAll: self selector! !

!STTestCase methodsFor: 'running' stamp: 'lr 4/3/2006 20:15'!
run
	self instance perform: selector! !

!STTestCase methodsFor: 'accessing' stamp: 'lr 4/3/2006 09:49'!
selector
	^ selector! !

!STTestCase methodsFor: 'initialization' stamp: 'lr 4/3/2006 20:27'!
setSelector: aSelector
	selector := aSelector! !

!STTestCase methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:34'!
wrapped
	| selectors |
	selectors := (Pragma allNamed: #decoration from: self class to: STTest)
		collect: [ :each | each selector ].
	^ self pragmas
		inject: self 
		into: [ :result :each |
			(selectors includes: each keyword)
				ifFalse: [ result ]
				ifTrue: [ 
					result 
						perform: each keyword
						withArguments: each arguments ] ]! !

STTestCase subclass: #STTestMethod
	instanceVariableNames: 'class instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Core'!

!STTestMethod class methodsFor: 'instance-creation' stamp: 'lr 4/3/2006 20:28'!
class: aClass selector: aSelector
	^ self new setClass: aClass; setSelector: aSelector! !

!STTestMethod methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:19'!
accept: aVisitor
	aVisitor visitTestMethod: self! !

!STTestMethod methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:15'!
instance
	^ instance! !

!STTestMethod methodsFor: 'initialization' stamp: 'lr 4/3/2006 20:27'!
setClass: aClass
	class := aClass! !

!STTestMethod methodsFor: 'initialization' stamp: 'lr 4/3/2006 20:39'!
setInstance: anObject
	instance := anObject! !

!STTestMethod methodsFor: 'running' stamp: 'lr 4/3/2006 20:17'!
setUp
	self setInstance: self species new.
	(Pragma allNamed: #setUp in: self species)
		do: [ :each | self instance perform: each selector ]! !

!STTestMethod methodsFor: 'accessing' stamp: 'lr 4/3/2006 20:27'!
species
	^ class! !

!STTestMethod methodsFor: 'running' stamp: 'lr 4/3/2006 20:18'!
tearDown
	(Pragma allNamed: #tearDown in: self species)
		do: [ :each | self instance perform: each selector ].
	self setInstance: nil! !

STTest subclass: #STTestSuite
	instanceVariableNames: 'tests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Core'!

!STTestSuite class methodsFor: 'accessing' stamp: 'lr 4/3/2006 09:43'!
suite
	^ self new! !

!STTestSuite methodsFor: 'visiting' stamp: 'lr 4/3/2006 09:19'!
accept: aVisitor
	aVisitor visitTestSuite: self! !

!STTestSuite methodsFor: 'adding' stamp: 'lr 3/31/2006 14:17'!
addAll: aCollection
	self tests addAll: aCollection! !

!STTestSuite methodsFor: 'adding' stamp: 'lr 3/31/2006 14:16'!
add: aTest
	self tests add: aTest! !

!STTestSuite methodsFor: 'initialization' stamp: 'lr 3/29/2006 12:15'!
initialize
	super initialize.
	tests := Set new! !

!STTestSuite methodsFor: 'copying' stamp: 'lr 4/3/2006 20:24'!
postCopy
	super postCopy.
	tests := self tests copy! !

!STTestSuite methodsFor: 'accessing' stamp: 'lr 3/31/2006 14:19'!
tests
	^ tests! !

!STTestSuite methodsFor: 'operators' stamp: 'lr 4/3/2006 20:23'!
, aTestSuite
	^ self copy addAll: aTestSuite tests! !

!STTest class methodsFor: 'accessing' stamp: 'lr 4/3/2006 09:42'!
suite
	self subclassResponsibility! !

!STTest methodsFor: 'decorating' stamp: 'lr 4/3/2006 20:31'!
group: aString
	<decoration>

	^ (STGroupedTest on: self) name: aString! !

!STTest methodsFor: 'decorating' stamp: 'lr 4/3/2006 20:32'!
ignore
	<decoration>
	
	^ STIgnoredTest on: self! !

!STTest methodsFor: 'accessing' stamp: 'lr 4/18/2006 07:27'!
owner
	"Answer the owning test, Decorations should override this message to answer the actual test."
	
	^ self! !

!STTest methodsFor: 'decorating' stamp: 'lr 4/3/2006 20:32'!
repeat: anInteger
	<decoration>
	
	^ (STRepeatedTest on: self) count: anInteger! !

!STTest methodsFor: 'running' stamp: 'lr 3/31/2006 07:23'!
setUp! !

!STTest methodsFor: 'running' stamp: 'lr 3/31/2006 07:23'!
tearDown! !

!STTest methodsFor: 'decorating' stamp: 'lr 4/3/2006 20:32'!
timeout: anInteger
	<decoration>
	
	^ (STTimeoutTest on: self) timeout: anInteger! !

Object subclass: #STTestFinder
	uses: STVisitor
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakTesting-Visitor'!

STTestFinder class
	uses: STVisitor classTrait
	instanceVariableNames: ''!

!STTestFinder methodsFor: 'accessing' stamp: 'lr 4/18/2006 07:28'!
groups
	^ groups! !

!STTestFinder methodsFor: 'initialization' stamp: 'lr 4/18/2006 07:33'!
initialize
	super initialize.
	groups := Dictionary new! !

!STTestFinder methodsFor: 'visiting-decoration' stamp: 'lr 4/18/2006 07:38'!
visitGroupedTest: aTest
	self visitDecoration: aTest.
	(self groups at: aTest name ifAbsentPut: [ Set new ])
		add: aTest owner! !
